// $Id: J4UnionSolid.cc,v 1.4 2004/06/08 13:30:40 fujiik Exp $
//*************************************************************************
//* --------------------
//* J4UnionSolid
//* --------------------
//* (Description)
//*     
//* (Update Record)
//*	2001/08/26  K.Hoshina	Original version.
//*************************************************************************

#include "J4UnionSolid.hh"

///////////////////////////////////////////////////////////////////
//
// Transfer all data members to G4BooleanSolid which is responsible
// for them. pName will be in turn sent to G4VSolid

J4UnionSolid:: J4UnionSolid( const G4String& pName,
                                     G4VSolid* pSolidA ,
                                     G4VSolid* pSolidB   ):
		G4UnionSolid(pName,pSolidA,pSolidB), fIsOwner(true)
                , fSolidA(pSolidA), fSolidB(pSolidB)
{
   ;
}

/////////////////////////////////////////////////////////////////////
//
//
 
J4UnionSolid:: J4UnionSolid( const G4String& pName,
                                     G4VSolid* pSolidA ,
                                     G4VSolid* pSolidB ,
                                     G4RotationMatrix* rotMatrix,
                               const G4ThreeVector& transVector    ):
		G4UnionSolid(pName,pSolidA,pSolidB,rotMatrix,transVector)
		, fIsOwner(true) , fSolidA(pSolidA), fSolidB(pSolidB)

{
   ;
}

///////////////////////////////////////////////////////////
//
//
 
J4UnionSolid:: J4UnionSolid( const G4String& pName,
                                     G4VSolid* pSolidA ,
                                     G4VSolid* pSolidB ,
                               const G4Transform3D& transform  ):
		G4UnionSolid(pName,pSolidA,pSolidB,transform)
		, fIsOwner(true) , fSolidA(pSolidA), fSolidB(pSolidB)

{
   ;
} 


///////////////////////////////////////////////////////////
//
//

J4UnionSolid::~J4UnionSolid()
{
#ifdef __GEANT451_OR_OLDER__
   // It's now G4's privilage to delete solids.
   if (fIsOwner) {
   	if (fSolidA) delete fSolidA;
   	if (fSolidB) delete fSolidB;
   }
#endif
}


