#ifndef __MYPRIMARYPARTICLE__
#define __MYPRIMARYPARTICLE__
//*************************************************************************
//* -----------------
//* MyPrimaryParticle
//* -----------------
//* (Description)
//* 	Class to cross-reference primary particles and break points.
//* (Update Record)
//*	2007/08/21  K.Fujii	Original version.
//*************************************************************************

#include "S4PrimaryParticle.h"
#include <vector>
#include <map>

class MyPrimaryParticle : public S4PrimaryParticle {
public:
   MyPrimaryParticle(S4PrimaryParticle *ppp);
   virtual ~MyPrimaryParticle();

   inline MyPrimaryParticle *GetParentPtr     () { return fParentPtr; }
          MyPrimaryParticle *GetGrandParentPtr();

   static void Initialize(TObjArray *pplist);
   static void DebugPrint();
   static MyPrimaryParticle *GetMyPPPtr(Int_t j4tkid);

private:
   MyPrimaryParticle                         *fParentPtr;      //  pointer to parent
   static const UInt_t                        kUsed = BIT(21); //! a flag
   static std::vector<MyPrimaryParticle*>     fgPPList;        //! list of primary particles
   static std::map<Int_t, MyPrimaryParticle*> fgPPMap;         //! TrackID to PrimaryParticle map
   
   ClassDef(MyPrimaryParticle, 1) // MyPrimaryParticle class
};

#endif

