#ifndef __S4BabyMCTRUTH__
#define __S4BabyMCTRUTH__

//*************************************************************************
//* ----------------
//* S4BabyMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4BabyMCTruth		: steering class
//* (Update Record)
//*	2002/08/27  R.Kuboshima	 
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"

#include "S4BabyTypeDef.h"

class S4BabyMCTruth : public S4VMCTruth {
	
public:
   S4BabyMCTruth(const Char_t *name="S4BabyMCTruth",
	         const Char_t *title="Get Baby ExactHit data");
	        
   virtual ~S4BabyMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);
   void   DebugPrint(const Char_t *opt = "");
   
   void   RemoveDeltaRayHits(Bool_t flag = kTRUE) 
   			{ fRemoveDeltaRayHits = flag; }
   void   JoinSeparatedHits(Bool_t flag = kTRUE) 
   			{ fJoinSeparatedHits = flag; }
   
private:
   Bool_t	fRemoveDeltaRayHits;	//
   Bool_t	fJoinSeparatedHits;	//

   ClassDef(S4BabyMCTruth, 1) // Read Baby ExactHit Data
};

#endif




