#ifndef __S4BCALMCTRUTHBUF__
#define __S4BCALMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2006/02/01  A.Miyamoto 	Original version.
//*************************************************************************

#include "S4VMCTruthBuf.h"
#include "S4BCALMCTruth.h"

// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4BCALMCTruthBuf : public S4VMCTruthBuf {

public:
  S4BCALMCTruthBuf(const Char_t *name  = "S4BCALMCTruthBuf",
                  const Char_t *title = "BCAL MCTruth Buf", 
                  S4BCALMCTruth *mod =0,
		  Int_t         bufsize = 20000);

  S4BCALMCTruthBuf(S4BCALMCTruth *mod,
                  const Char_t *name = "S4BCALMCTruthBuf",
		  const Char_t *title = "BCAL MCTruth Buf",
                  Int_t         bufsize = 20000);

  virtual   ~S4BCALMCTruthBuf();


  TObjArray *GetInputBufPtr()                { return fInputBufPtr; }
  TObjArray *GetPreHitsPtr()                 { return fPreHitsPtr;  } 
  void       SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
  void       SetPreHitsPtr(TObjArray *prep)  { fPreHitsPtr  = prep; }

  Bool_t     ReadFile();

  void       UpdatePtrs();

private:
  TObjArray *fInputBufPtr;             //! 
  TObjArray *fPreHitsPtr;              //!
  
  ClassDef(S4BCALMCTruthBuf, 1) // CAL raw data buffer
};

#endif

