#ifndef __S4BCALPreHit__
#define __S4BCALPreHit__

//////////////////////////////////////////////////////////////////////
//
//  JSFJ4 CAL PreHit Data
//
//  2004/10/16  Allister Sanchez   Original version.
//
//  $Id: S4BCALPreHit.h,v 1.1 2006/06/07 01:22:02 miyamoto Exp $
/////////////////////////////////////////////////////////////////////

#include "S4VExactHit.h"
// #include "S4TPCPostHit.h"
#include <TVector3.h>
#include <TString.h>

class J4IRBCALPreHit;

// ***************************************************************
class S4BCALPreHit : public S4VExactHit
{
 public:
  S4BCALPreHit();
  S4BCALPreHit(Int_t      postHitID,      // posthit ID
	      Int_t      preHitID,       // prehit ID
	      Int_t      trackID,        // track ID 
	      Int_t      motherTrackID,  // mother track ID
	      Int_t      pcode,          // PDG code
	      Double_t   charge,         // charge
	      TVector3   pos,            // Injection position [cm]
	      Double_t   tof,            // TOF      [nsec]
	      TVector3   mom,            // momentum [GeV] 
	      Double_t   etot,           // energy
	      Double_t   edep,           // energy deposit [GeV]      
	      TVAddress *p = 0);         // address ptr
  S4BCALPreHit(J4IRBCALPreHit *prehit);
  virtual ~S4BCALPreHit();

  static void   SetSortBy (Char_t *opt="");
         Int_t  Compare   (const TObject*) const;
         Bool_t IsSortable()               const;

  inline Int_t         GetPostHitID     ()  const { return fPostHitID;       }
  inline Int_t         GetPreHitID      ()  const { return GetHitID();       }
  inline Double_t      GetEnergy        ()  const { return GetTotalEnergy(); }
  inline TVector3      GetInjectionPoint()  const { return GetPosition();    }
  //  inline S4TPCPostHit* GetPostHitPtr()      const { return fPostHitPtr;      }
  //  inline void          SetPostHitPtr(S4TPCPostHit *p){fPostHitPtr = p; }

  void Print(Option_t *opt="") const;

 private:
  TString       fParticleName;  //  Particle Name
  Int_t         fPostHitID;     //  post hit id
  //  S4TPCPostHit *fPostHitPtr;    //! post hit ptr

  ClassDef(S4BCALPreHit, 1) // S4BCALPreHit class
};

#endif
