#ifndef __S4MUDMCTRUTHBUF__
#define __S4MUDMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2004/11/24  S.Yamamoto	Original version.
//*************************************************************************

#include "S4VMCTruthBuf.h"
#include "S4MUDMCTruth.h"

// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4MUDMCTruthBuf : public S4VMCTruthBuf {

public:
  S4MUDMCTruthBuf(const Char_t *name  = "S4MUDMCTruthBuf",
                  const Char_t *title = "MUD MCTruth Buf", 
                  S4MUDMCTruth *mod =0,
		  Int_t         bufsize = 20000);

  S4MUDMCTruthBuf(S4MUDMCTruth *mod,
                  const Char_t *name = "S4MUDMCTruthBuf",
		  const Char_t *title = "MUD MCTruth Buf",
                  Int_t         bufsize = 20000);

  virtual   ~S4MUDMCTruthBuf();


  TObjArray *GetInputBufPtr()                 { return fInputBufPtr;  }
  TObjArray *GetPreHitsPtr()                  { return fPreHitsPtr;   } 
  void       SetInputBufPtr(TObjArray *bufp)  { fInputBufPtr = bufp;  }
  void       SetPreHitsPtr(TObjArray *prep)   { fPreHitsPtr  = prep;  }

  Bool_t     ReadFile();

  void       UpdatePtrs();

private:
  TObjArray *fInputBufPtr;             //! 
  TObjArray *fPreHitsPtr;              //!
  
  ClassDef(S4MUDMCTruthBuf, 1) // MUD raw data buffer
};

#endif

