#ifndef __TKALTRACK__
#define __TKALTRACK__
//*************************************************************************
//* =================
//*  TKalTrack Class
//* =================
//*
//* (Description)
//*   Track class for Kalman filter
//* (Requires)
//*     TVKalSystem
//* (Provides)
//*     class TKalTrack
//* (Update Recored)
//*   2003/09/30  Y.Nakashima	Original version.
//*   2005/02/23  A.Yamaguchi	Added a new data member fMass and its
//*                             getter and setter.
//*
//*************************************************************************
                                                                                
#include "TVKalSystem.h"
#include "TKalTrackState.h"

//_____________________________________________________________________
//  ------------------------------
//  Sample Kalman Filter class
//  ------------------------------
//
                                                                                
class TKalTrack : public TVKalSystem {
public:
   TKalTrack(Int_t n = 1);
   ~TKalTrack() {} 

   inline virtual void         SetMass(Double_t m) { fMass = m;    }
   inline virtual Double_t     GetMass() const     { return fMass; }

   Double_t FitToHelix(TKalTrackState &a, TKalMatrix &C, Int_t &ndf);

private:
   Double_t     fMass;        // mass [GeV]

   ClassDef(TKalTrack,1)  // Base class for Kalman Filter
};
                                                                                
//=======================================================
// inline functions
//=======================================================
                                                                                
#endif
