//*************************************************************************
//* --------------------
//* S4BabyTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2002/08/28  R.Kuboshima
//*************************************************************************

#include "S4BabyTrackMaker.h"
#include "S4BabyTrackMakerBuf.h"
#include "S4VMCTruth.h"
#include "JSFSteer.h"


ClassImp(S4BabyTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4BabyTrackMaker::S4BabyTrackMaker(const char *name, const char *title)
                : U4VTrackMaker(name,title)
{ 
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4BabyTrackMaker::~S4BabyTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4BabyTrackMaker::Initialize()
{
	std::cerr <<" S4BabyTrackMaker Initialize called" << std::endl;
	fEventBuf = new S4BabyTrackMakerBuf(this);
	
	return kTRUE;
}

//=====================================================================
//* BeginRun() ------------------------------------------------------

Bool_t S4BabyTrackMaker::BeginRun(Int_t run)
{
	return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4BabyTrackMaker::Process(Int_t ev)
{
	
	S4VMCTruth *mctp
		= (S4VMCTruth*)gJSF->FindModule("S4BabyMCTruth");
	S4VMCTruthBuf *mctbufp = (S4VMCTruthBuf *)mctp->EventBuf();

	S4BabyTrackMakerBuf* tmbufp = (S4BabyTrackMakerBuf *)EventBuf();
	tmbufp->SetInputDataBufPtr(mctbufp);	
	tmbufp->MakeTracks();

	return kTRUE;
}







