#ifndef __S4CALANALYSIS__
#define __S4CALANALYSIS__
//*************************************************************************
//* -----------
//* S4CALAnalysis
//* -----------
//* (Description)
//* 	Clasess to analyze CAL data.
//* (Update Record)
//*	2004/10/24  S.Yamamoto	Original version.
//*	2004/12/31  S.Yamamoto	added CALEne.
//*************************************************************************

#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"

#include "S4CALCluster.h"


class S4CALAnalysis : public JSFModule {
public:
   S4CALAnalysis(const Char_t *name  = "S4CALAnalysis",
		 const Char_t *title = "CAL Analysis");
   virtual ~S4CALAnalysis();

   Bool_t Initialize();
   Bool_t Process(Int_t ev);
#if 0    
   void Draw(Option_t /* *option = "" */);
#endif

private:
   virtual void MonitorClusters(Int_t ev);
   
private:
   TH1D     *fHCALEne;            //!
   TH1D     *fHClusterEne;        //!
   TH1D     *fHPreHitEne;         //!
   TH1D     *fHPostHitEne;        //!
   TH1D     *fHEneRatio0;         //!
   TH1D     *fHEneRatio1;         //!
   TH1D     *fHEneRatio2;         //!
   TH1D     *fHTrackEne;          //!
   TH1D     *fHTrackEne2;         //!
   TH1D     *fHEneRatiotk;        //!
   TH1D     *fHEneRatiotk2;       //!
   TH1D     *fHDistDiff;          //!
   TH2D     *fHEneTof;            //!
   TH2D     *fHEhitTof;           //!
   TH2D     *fHdTdP;              //!

   ClassDef(S4CALAnalysis, 1) // CAL Analysis class
};

#endif

