//*************************************************************************
//* ---------------------
//* S4CALEMClusterMaker Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*
//* (Provides)
//*
//* (Update Record)
//*
//*************************************************************************
#include "S4CALMuonClusterMaker.h"
#include "S4TPCPostHit.h"
#include "S4CALPreHit.h"
#include "S4CALHit.h"
#include "S4CALExactHit.h"
#include "S4HYBTrackMakerBuf.h"

#include "JSFSteer.h"
#include "TNtuple.h"
#include <iostream>


ClassImp(S4CALMuonClusterMaker)


//=====================================================================
//* constructor -------------------------------------------------------
S4CALMuonClusterMaker::S4CALMuonClusterMaker()
{
}


//=====================================================================
//* destructor --------------------------------------------------------

S4CALMuonClusterMaker::~S4CALMuonClusterMaker()
{
}

//==========================================================================
//* MakeMuonClusters -------------------------------------------------------

void S4CALMuonClusterMaker::MakeMuonClusters(std::map<Int_t,S4CALRealCluster*> &clmap,
					     std::map<Int_t,S4CALSmallCluster*> &sclmap,
					     std::map<Int_t,S4HYBTrack*> &trkmap)
{

  if(sclmap.size() == 0) return;

  std::map<Int_t, S4CALSmallCluster*>::iterator itr;


  ///// Cheating method!! ///////////////////////////////////////
  std::multimap<Int_t,S4CALSmallCluster*> sclpost;
  typedef std::multimap<Int_t,S4CALSmallCluster*>::iterator MULTIITR;
  MULTIITR mitr;

  //--- Lock muon origined small clusters ------
  std::map<Int_t,std::pair<Int_t,Double_t> > postmap;
  std::map<Int_t,std::pair<Int_t,Double_t> >::iterator poitr;
  for(itr = sclmap.begin(); itr != sclmap.end(); itr++){
    if(itr->second->IsLocked()) continue;
    if(itr->second->IsMuon(0.9)){
      itr->second->Lock();
      postmap = itr->second->GetPostHitIDMap();
      Double_t emax      = 0.;
      Int_t    maxpostID = -1;
      for(poitr = postmap.begin(); poitr != postmap.end(); poitr++){
	Double_t tmpedep = (poitr->second).second;
	if(TMath::Abs((poitr->second).first) == 13 && tmpedep > emax){
	  emax = tmpedep;
	  maxpostID = poitr->first;
	}
      }
      if(maxpostID > 0)
	sclpost.insert(std::pair<Int_t,S4CALSmallCluster*>(maxpostID,itr->second));
    }
  }
  //--------------------------------------------

  //----- choose muon tracks by cheating method ---------
  std::map<Int_t,S4HYBTrack*>::iterator mutitr;

  for(mutitr = trkmap.begin(); mutitr != trkmap.end(); mutitr++){

    if(TMath::Abs(mutitr->second->GetPDGCode()) == 13){
      S4CALRealCluster *mucl = new S4CALRealCluster();
      mucl->AddTrackPtr(mutitr->second);
      mucl->SetParticleType(kgMuon_p);
      mutitr->second->Lock();

      std::pair<MULTIITR,MULTIITR> itr_range;
      itr_range = sclpost.equal_range(mutitr->second->GetTrackID());
      for(mitr = itr_range.first; mitr != itr_range.second; mitr++){
	mucl->Add(mitr->second);
      }

      mucl->Update();
      clmap.insert(std::pair<Int_t,S4CALRealCluster*>(mucl->GetClusterID(), mucl));
    }

  }
  //-----------------------------------------------------

}
