#ifndef __S4CDCHITMAKERBUF__
#define __S4CDCHITMAKERBUF__

//*************************************************************************
//* ---------------------
//* S4CDCHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4CDCHitMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

#include "U4CDCHitMakerBuf.h"
#include "S4CDCHitMaker.h"


class S4CDCHitMakerBuf : public U4CDCHitMakerBuf {
friend class S4CDCHitMaker;

public:

  S4CDCHitMakerBuf(U4CDCTimeToXRelation *calib = 0,
  	           const char *name="S4CDCHitMakerBuf",
	           const char *title="CDC Hit data", 
	           S4CDCHitMaker *module=0, Int_t bufsize = 50);
  S4CDCHitMakerBuf(S4CDCHitMaker *module,
  	           U4CDCTimeToXRelation *calib,
	           const char *name="S4CDCHitMakerBuf",
	           const char *title="CDC Hit data",
	           Int_t bufsize = 50);
		    
  virtual ~S4CDCHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "") 
                                 { U4CDCHitMakerBuf::DebugPrint(); }
  virtual const TObjArray *GetInputTObjArrayPtr() const { return fInputBufPtr; }
    
protected:  
  virtual void	MakeHits() ;	// Make CDC Hits
  
private:
  void AppendCell  (TObjArray* celltmpp,  U4CDCHitLayer* layercurp);
  void AppendLayer (TObjArray* layertmpp, TObjArray* outputbufp);

private:
  TObjArray *fInputBufPtr;
  
  ClassDef(S4CDCHitMakerBuf, 1) // Cluster data buffer
};



#endif
