#ifndef __S4HYBTRACK__
#define __S4HYBTRACK__
//*************************************************************************
//* ----------------
//* S4HYBTrack Class
//* ----------------
//* (Description)
//*	Class to represent a (smeared) hybrid track.
//*    	U4HYBTrack is an array of track segments.
//* (Requires)
//*	U4HYBTrack
//* (Provides)
//*	S4HYBTrack
//* (Update Record)
//*     2004/09/07  K.Fujii      Original version.
//*************************************************************************

#include "U4HYBTrack.h"
#include "S4VTrack.h"
#include "TAttDrawable.h"

class S4HYBTrack : public U4HYBTrack, public S4VTrack, public TAttDrawable {
public:
  S4HYBTrack(U4VTrackMaker *trkmp = 0);
  virtual ~S4HYBTrack();

  // ----------------------------------------------------------------------
  // -----------------------------------
  //  Virtuals of U4HYBTrack to override
  // -----------------------------------
         virtual Int_t       GetPDGCode();
         virtual Int_t       GetTrackID();
         virtual Int_t       GetMotherTrackID();

         virtual void        DebugPrint(const Char_t *opt = "");
  // ----------------------------------------------------------------------
  // -------------------------------------
  //  Virtuals of TAttDrawable to override
  // -------------------------------------
         using TAttDrawable::Draw;
         virtual void        Draw(Int_t color, const Char_t *opt = "");
  
private:
 
  ClassDef(S4HYBTrack, 1)                     // HYB Track
};

// ------------------------------------------------------------------------
//  Inline functions if any
// ------------------------------------------------------------------------

#endif
