//*************************************************************************
//* --------------------
//* U4VHitMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include <iostream>
#include "S4ITMCTruthBuf.h"
#include "S4ITHitMakerBuf.h"
#include "JSFSteer.h"
//#define __DEBUG__
using namespace std;

ClassImp(S4ITHitMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4ITHitMaker::S4ITHitMaker(const Char_t *name, const Char_t *title)
            : U4ITHitMaker(name,title)
{
#ifdef __DEBUG__
   cerr << " constructor for S4ITHitMaker is called..." << endl;
#endif
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4ITHitMaker::~S4ITHitMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4ITHitMaker::Initialize()
{
#ifdef __DEBUG__
   cerr << "S4ITHitMaker::Initialize is called..." << endl;
#endif

   fEventBuf = new S4ITHitMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4ITHitMaker::Process(Int_t /*ev*/)
{
#ifdef __DEBUG__
   cerr << " S4ITHitMaker::Process() is called..." << endl;
#endif
   JSFModule *mctp = gJSF->FindModule("S4ITMCTruth","quiet");
   if (!mctp) return kTRUE;
   S4ITMCTruthBuf *mctbufp = static_cast<S4ITMCTruthBuf *>(mctp->EventBuf());
   S4ITHitMakerBuf *hmbufp = static_cast<S4ITHitMakerBuf *>(EventBuf());

   hmbufp->SetInputDataBufPtr(mctbufp);	
   hmbufp->SetInputBufPtr(mctbufp->GetExactHitsPtr());

   hmbufp->MakeHits();

   return kTRUE;
}
