//*************************************************************************
//* --------------------
//* S4ITTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/06  A.Yamaguchi    Original version.
//*************************************************************************

#include "S4ITTrackMaker.h"
#include "S4ITTrackMakerBuf.h"
#include <iostream>
//#define __DEBUG__

ClassImp(S4ITTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4ITTrackMaker::S4ITTrackMaker(const Char_t *name, const Char_t *title)
              : U4ITTrackMaker(name,title)
{
}

S4ITTrackMaker::S4ITTrackMaker(U4ITKalDetector *det,
                               const Char_t    *name,
                               const Char_t    *title)
              : U4ITTrackMaker(det, name, title)
{
#ifdef __DEBUG__ 
   std::cerr << " constructor for S4ITTrackMaker is called..." << std::endl;
#endif
}

//=====================================================================
//* destructor --------------------------------------------------------

S4ITTrackMaker::~S4ITTrackMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4ITTrackMaker::Initialize()
{
#ifdef __DEBUG__
   std::cerr <<" S4ITTrackMaker Initialize called" << std::endl;
#endif
   fEventBuf = new S4ITTrackMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4ITTrackMaker::Process(Int_t  /* ev */)
{
   S4ITTrackMakerBuf *tmbufp = static_cast<S4ITTrackMakerBuf *>(EventBuf());
   tmbufp->SetInputDataBufPtr(gJSF->FindModule("S4ITHitMaker")->EventBuf());

   return kTRUE;
}

