#ifndef __S4TPCANALYSIS__
#define __S4TPCANALYSIS__
//*************************************************************************
//* -----------
//* S4TPCAnalysis
//* -----------
//* (Description)
//* 	Clasess to analyze TPC data.
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "TNtupleD.h"
#include "JSFModule.h"
//#include "ANL4DVector.h"
//class S4TPCTrack;

class S4TPCAnalysis : public JSFModule {
public:
   S4TPCAnalysis(const Char_t *name  = "S4TPCAnalysis",
                 const Char_t *title = "TPC Analysis");
   virtual ~S4TPCAnalysis();

   virtual Bool_t Initialize();
   virtual Bool_t Process(Int_t ev);
   virtual Bool_t Terminate();
    
   void Draw(Option_t *option = "");

private:
   //ANL4DVector Get4DVector(S4TPCTrack *ttp);
   virtual void MonitorTracks(Int_t ev);
   
private:
   TNtupleD *fTrackHistPtr;   //!
   TNtupleD *fHitHistPtr;     //!
   //TNtupleD *fMassHistPtr;    //!

   ClassDef(S4TPCAnalysis, 1) // TPC Analysis class
};

#endif

