#ifndef __S4TPCHITMAKERBUF__
#define __S4TPCHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4TPCHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4TPCHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include "U4TPCHitMakerBuf.h"
#include "S4TPCHitMaker.h"

class S4TPCHitMakerBuf : public U4TPCHitMakerBuf {
friend class S4TPCHitMaker;

public:
  S4TPCHitMakerBuf(const Char_t  *name    ="S4TPCHitMakerBuf",
                   const Char_t  *title   ="TPC Hit data", 
                   S4TPCHitMaker *module  = 0,
                   Int_t          bufsize = 500);

  S4TPCHitMakerBuf(S4TPCHitMaker *module,
                   const Char_t  *name    = "S4TPCHitMakerBuf",
                   const Char_t  *title   = "TPC Hit data",
                   Int_t          bufsize = 500);
          
  virtual ~S4TPCHitMakerBuf();

  static void SetMergeRange(Double_t rphi, Double_t z)
  {   
     fgMergeRangeRPhi = rphi;
     fgMergeRangeZ    = z;
  }
  static void SwitchOnMergeHit () { fgIsMergeHit = kTRUE;  }
  static void SwitchOffMergeHit() { fgIsMergeHit = kFALSE; }

private:  
  void MergeHit(TObjArray &buf);
  virtual void MakeHits();   // Make TPC Hits

private:  
  TObjArray *fInputBufPtr;
  static Double_t fgMergeRangeRPhi; 
  static Double_t fgMergeRangeZ; 
  static Bool_t   fgIsMergeHit; 
  
  ClassDef(S4TPCHitMakerBuf, 1) // Cluster data buffer
};

#endif
