#ifndef __S4TPCTRACKHIT__
#define __S4TPCTRACKHIT__
//*************************************************************************
//* ---------------------
//* S4TPCTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4TPCTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4TPCHit.h"
#include "U4TPCTrackHit.h"


class S4TPCTrackHit : public U4TPCTrackHit {
friend class S4TPCTrack;
public:
  S4TPCTrackHit();
  S4TPCTrackHit(S4TPCHit *ht);
  S4TPCTrackHit(const S4TPCTrackHit &hit);
  virtual ~S4TPCTrackHit();

  static   void   SetSortBy(Char_t *opt = "Time");
  virtual  Int_t  Compare(const TObject *obj) const;

  inline virtual S4TPCHit *GetHitPtr  () {
     return  dynamic_cast<S4TPCHit *> (U4VTrackHit::GetHitPtr());
  }
       
private:

  ClassDef(S4TPCTrackHit, 1)       // TPC Hit 
};


#endif
