//
// tpcanl.C
//
// 

#include <iomanip>

TFile *foutp;

#if 0
extern TH2D *hRDX;
extern TH2D *hRDXmin;
#endif

void tpcanl(Int_t run = 0)
{
  gROOT->Reset();

#if 1
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libS4MCTruth.so");
  gSystem->Load("libS4VTXMCTruth.so");
  gSystem->Load("libS4CALMCTruth.so");
  gSystem->Load("libS4ITMCTruth.so");
  gSystem->Load("libS4CTMCTruth.so");
  gSystem->Load("libS4TPCMCTruth.so");
  gSystem->Load("libS4CDCMCTruth.so");
  gSystem->Load("libJSFJ4.so");

  gSystem->Load("libS4Kalman.so");  
  gSystem->Load("libS4Geom.so");  
  gSystem->Load("libS4KalTrack.so");  
  gSystem->Load("libU4VHitMaker.so");
  gSystem->Load("libU4KalDetector.so");  
  gSystem->Load("libU4TPCKalDetector.so");  
  gSystem->Load("libU4TPCHitMaker.so");
  gSystem->Load("libS4TPCHitMaker.so");
  gSystem->Load("libU4VTrackMaker.so");  
  gSystem->Load("libS4Kern.so");  
  gSystem->Load("libU4TPCTrackMaker.so");  
  gSystem->Load("libS4TPCTrackMaker.so");  
  gSystem->Load("libS4TPCAnalysis.so");
#endif

  gErrorAbortLevel = kWarning + 1; 
  //gRandom->SetSeed();
       
  JSFSteer *jsf = new JSFSteer();
    
  Char_t fname[13];
  foutp = new TFile("jsf.root","RECREATE"); //  Output file.
  TFile & fout = *foutp;
  
  if (!run) run = jsf->Env()->GetValue("JSFSteer.RunNo",1615);  
  cerr << " RunNo = " << run << endl;

  jsf->SetOutput(fout);


  Int_t nevent=jsf->Env()->GetValue("JSFSteer.Nevent",98);  
  Int_t minevt=0;
  Int_t maxevt=minevt+nevent;

  S4VMCTruth::SetInputFileName("hit.dat");

  S4TPCMCTruth     *mctruth     = new S4TPCMCTruth();  
#if 1
  U4TPCKalDetector *tpcdet      = new U4TPCKalDetector();
#if 0
  tpcdet->SwitchOffMS();
#else
  tpcdet->SwitchOnMS();
#endif
#endif
  S4TPCHitMaker    *hitmaker    = new S4TPCHitMaker();
  S4TPCTrackMaker  *trackmaker  = new S4TPCTrackMaker(tpcdet);
  S4TPCAnalysis    *analysis    = new S4TPCAnalysis();
#endif

//==================================
// set parameters
//----------------------------------
   S4TPCPadHit::SetSpatialResolution("flat"); // flat or experimental
   S4TPCPadHit::SetT0offset(0.);              // nsec
#if 0
  // Remove Dalta-Ray hits ....    
     mctruth->RemoveDeltaRayHits(kFALSE);
     mctruth->JoinSeparatedHits(kFALSE);

  // Saturation effect ....    
     analysis->SaturationOff();
 
  // Two-track Separation ....
     Int_t twotrack = jsf->Env()->GetValue("JSFSteer.TwoTrackSeparation",1.0);  
     Double_t twotracksep = twotrack / 10000.; 
     S4TPCHitWire::SetTwoHitSeparation(twotracksep);
     cerr << " twotracksep = " << twotracksep << endl;  
     S4TPCHitWire::SetTwoHitSeparationZ(0.3);
 
  // Set IP constraint ....
  // S4TPCTrack::SetIPConstraint(kTRUE);
#endif          
//----------------------------------
//==================================
 
   jsf->Initialize();
    
  jsf->BeginRun(run);      // Set run number

  for(Int_t ev=minevt;ev<=maxevt;ev++){
    
    cerr << " ---- Event " << ev << " ----" << endl;
    Int_t ib;
    if( ! jsf->Process(ev) ) {
      cerr << "jsf->Process is faild." << endl;
      jsf->FillTree();
      jsf->Clear();
      break;
    }
    jsf->FillTree();
    jsf->Clear();
  }
  jsf->Terminate();
  fout.Write();

}



