#ifndef __U4IPHIP__
#define __U4IPHIP__
//*************************************************************************
//* ---------------------
//* U4IPKalHit Class
//* ---------------------
//* (Description)
//* (Requires)
//*     TObjArray
//* (Provides)
//* (Update Record)
//*     2004/08/26  A.Yamaguchi    Original Ver.
//*************************************************************************

#include "U4VKalHit.h"
#include "U4IPMeasLayer.h"

class U4IPKalHit : public TVTrackHit {
public:
   U4IPKalHit(Int_t m = kMdim);
   U4IPKalHit(const U4IPMeasLayer &ms,
                    Double_t      *x,
                    Double_t      *dx,
                    Double_t       b,
                    Int_t          m = kMdim);
   U4IPKalHit(const U4IPKalHit &hit);
   ~U4IPKalHit();

   virtual TKalMatrix XvToMv (const TVector3 &xv, Double_t t0) const;

   virtual void       DebugPrint(Option_t *opt = "") const;

   static U4IPKalHit *Create();

private:
   static Double_t  fgDX;      // sigma x [cm]
   static Double_t  fgDZ;      // sigma z [cm]
   static Double_t  fgBfield;  // b field [kG]

   ClassDef(U4IPKalHit,1)      // Sample hit class
};

#endif

