#ifndef __U4TPCKALHIT__
#define __U4TPCKALHIT__
//*************************************************************************
//* ---------------------
//* U4TPCKalHit Class
//* ---------------------
//* (Description)
//* (Requires)
//*     TObjArray
//* (Provides)
//* (Update Record)
//*     2004/08/26  A.Yamaguchi    Original Ver.
//*************************************************************************

#include "U4TPCMeasLayer.h"
#include "U4VKalHit.h"

class U4TPCKalHit : public U4VKalHit {
public:
   U4TPCKalHit(Int_t m = kMdim);
   U4TPCKalHit(const TObject       &hit, 
               const U4TPCMeasLayer &ms,
               Double_t             *x,
               Double_t             *dx,
               Int_t                 side,
               Double_t              v,
               Double_t              b,
               Int_t                 m = kMdim);
   U4TPCKalHit(const U4TPCKalHit &hit);
   ~U4TPCKalHit();

   inline               Int_t    GetSide  () const { return fSide;    }
   inline               Double_t GetVdrift() const { return fVdrift;  }

   inline void SetVdrift(Double_t v) { fVdrift = v; }

   virtual TKalMatrix XvToMv(const TVector3 &xv, Double_t t0) const;

   virtual void DebugPrint(Option_t *opt = "") const;

private:
   Int_t           fSide;         // (-z,+z) = (-1,+1)
   Double_t        fVdrift;       // drift velocity

   ClassDef(U4TPCKalHit,1)      // Sample hit class
};

#endif
