#ifndef __U4TPCTRACKMAKERBUF__
#define __U4TPCTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4TPCTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4TPCTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	    Original version.
//*************************************************************************

#include "JSFSteer.h"
#include "U4VTrackMakerBuf.h"
#include "U4TPCTrackMaker.h"
#include "U4TPCHitMakerBuf.h"

class U4TPCTrack;

class U4TPCTrackMakerBuf : public U4VTrackMakerBuf {
public:
  U4TPCTrackMakerBuf(const Char_t    *name  = "U4TPCTrackMakerBuf",
                     const Char_t    *title = "TPC Track data",
                     U4TPCTrackMaker *module = 0,
                     Int_t            bufsize = 2000);
  U4TPCTrackMakerBuf(U4TPCTrackMaker *module,
                     const Char_t    *name  = "U4TPCTrackMakerBuf",
                     const Char_t    *title = "TPC Track data",
                     Int_t            bufsize = 2000);
    
  virtual ~U4TPCTrackMakerBuf();
  
  virtual void  DebugPrint(const Char_t *opt = "Brief");

protected:  
  virtual void  MakeTracks();   // Make Tracks
  

  ClassDef(U4TPCTrackMakerBuf, 1) // Cluster data buffer
};

#endif

