#ifndef __U4VTXHVTX__
#define __U4VTXHVTX__
//*************************************************************************
//* ---------------------
//* U4VTXKalHit Class
//* ---------------------
//* (Description)
//* (Requires)
//*     TObjArray
//* (Provides)
//* (Update Record)
//*     2004/08/26  A.Yamaguchi    Original Ver.
//*************************************************************************

#include "U4VKalHit.h"
#include "U4VTXMeasLayer.h"

class U4VTXKalHit : public U4VKalHit {
public:
   U4VTXKalHit(Int_t m = kMdim);
   U4VTXKalHit(const TObject        &hit,
               const U4VTXMeasLayer &ms,
                     Double_t       *x,
                     Double_t       *dx,
                     Double_t        b,
                     Int_t           m = kMdim);
   U4VTXKalHit(const U4VTXKalHit &hit);
   ~U4VTXKalHit();

   virtual TKalMatrix XvToMv (const TVector3 &xv, Double_t t0) const;

   virtual void       DebugPrint(Option_t *opt = "") const;

private:

   ClassDef(U4VTXKalHit,1)      // Sample hit class
};

#endif

